project/config/routes.rb
Rails.application.routes.draw do
  get 'assignment/news'
  get 'assignment/divide'
  get 'home/about'
  root 'home#index'
  devise_for :users, controllers: { omniauth_callbacks: 'omniauth' }
end

project/app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

project/app/models/user.rb
class User < ApplicationRecord
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable, :trackable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :validatable, :omniauthable, omniauth_providers: [:google_oauth2]

  def self.create_from_google_data(provider_data)
    where(provider: provider_data.provider, uid: provider_data.uid).first_or_create do |user|
      user.email = provider_data.info.email
      user.password = Devise.friendly_token[0, 20]
    end
  end
end

project/app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
  before_action :current_uri

  def current_uri
    @url = request.original_url
  end
end

project/app/controllers/assignment_controller.rb
require 'nokogiri'
require 'open-uri'
class AssignmentController < ApplicationController
  def news
    @resp = getBKKNews
    @resp2 = getWNews
  end

  def divide
    config.logger = ActiveSupport::Logger.new("log/#{Rails.env}.log")
    logger.info 'About to divide by 0'
    8 / 0
  rescue ZeroDivisionError => e
    @err = e.message
    @str = e.backtrace
    # raise
  end

  def getBKKNews
    article = Struct.new(:title, :desc, :url, :image)
    url = URI.parse('https://www.bangkokpost.com/world')
    doc = Nokogiri::HTML.parse(URI.open(url))
    headline = doc.xpath('//article').search('div.listnews-h//div.listnews-text//h3/a')
    url = doc.xpath('//article').search('div.listnews-h//div.listnews-text//h3//a/@href')
    description = doc.xpath('//article').search('div.listnews-h//div.listnews-text/p')
    image = doc.xpath('//article').search('div.listnews-h//div.listnews-img//a//img/@data-src')
    arr = []
    headline.each_with_index do |val, index|
      str = url[index].text
      str = 'https://www.bangkokpost.com' + str
      art = article.new(val.text, description[index].text, str, image[index].text)
      arr << art
    end
    arr
  end

  def getWNews
    article = Struct.new(:title, :desc, :url, :image)
    url = URI.parse('https://www.nytimes.com/section/world')
    doc = Nokogiri::HTML.parse(URI.open(url))
    headline = doc.xpath('//article').search('//h2/a')
    url = doc.xpath('//article').search('//h2/a/@href')
    # description = doc.xpath('//article').search('//p')
    image = doc.xpath('//article').search('//figure//a//img/@src')
    arr = []
    headline.each_with_index do |val, index|
      str = url[index].text
      str = 'https://www.nytimes.com' + str
      art = article.new(val.text, '', str, image[index])
      arr << art
    end
    arr
  end
end

project/app/controllers/home_controller.rb
class HomeController < ApplicationController
  def index; end

  def about; end
end

project/app/controllers/omniauth_controller.rb
class OmniauthController < ApplicationController
  # skip_before_action :verify_authenticity_token

  def google_oauth2
    # binding.pry
    @user = User.create_from_google_data(request.env['omniauth.auth'])
    if @user.persisted?
      # p 'signed in'
      sign_in_and_redirect @user
    else
      # p 'redirect'
      flash[:error] = 'There was a problem signing in through Google. Please register or try signing in later.'
      redirect_to new_user_registration_url
    end
  end

  def failure
    flash[:error] = 'There was a problem signing you in. Please register or try signinig in later'
    redirect_to new_user_registration_url
  end
end

project/app/helpers/application_helper.rb
module ApplicationHelper
end

project/app/helpers/assignment_helper.rb
module AssignmentHelper
end

project/app/helpers/home_helper.rb
module HomeHelper
end

project/app/helpers/omniauth_helper.rb
module OmniauthHelper
end

project/app/views/assignment/divide.html.erb
<div class="card" style="width:80%; margin: 0 auto" >
  <h5 class="card-header">Exception</h5>
  <div class="card-body">
    <ul>
      <li class= "mb-3">
        Error message:  <%= @err%>
      </li>
      <li class= "mb-3">
        Explanation: 
        <p>Your click called a method to divide a number by zero. This causes rails to raise an exception called the 'ZeroDivisionError'. <br>
          The best practice is to raise the exception whenever it occurs, however for the purposes of this demonstration it is not.<br>
          Before the exception is handled, an error is logged in the production.log file in the server.</p>
      </li>
      <li class= "mb-3">
        Stack trace:  
        <p><%= @str%></p>
      </li>
    </ul>
  </div>
</div>
<br>

project/app/views/assignment/news.html.erb
<h2> Latest News</h2>
<br>
<div style= "margin-left: 8rem;">
  <button id= "btn1" type="button" class="btn btn-dark" >Bangkok Post</button>
  <button id= "btn2" type="button" class="btn btn-dark" style= "margin-left: 60px;">New York Times</button></div>
<br>
<div id="1" style= "display:block;" >
  <div class="row row-cols-1 row-cols-md-2">
    <% @resp.first(10).each do |resp | %>
      <div class="col mb-4" >
        <div class="card" style="width: 24rem; margin: 0 auto">
          <img src="<%= resp.image %>" class="card-img-top" alt="...">
          <div class="card-body">
            <h5 class="card-title"><%= resp.title %></h5>
            <p class="card-text"><%= resp.desc %></p>
            <a href= "<%= resp.url %>" class="btn btn-secondary">Read more</a>
          </div>
        </div>
      </div>
    <% end %>
  </div>
</div>
<div id="2" style= "display:none;">
  <div  class="row row-cols-1 row-cols-md-2" >
    <% @resp2.first(10).each do |resp2 | %>
      <div class="col mb-4">
        <div class="card" style="width: 24rem;margin: 0 auto">
          <img src="<%= resp2.image %>" class="card-img-top" alt="...">
          <div class="card-body">
            <h5 class="card-title"><%= resp2.title %></h5>
            <p class="card-text"><%= resp2.desc %></p>
            <a href= "<%= resp2.url %>" class="btn btn-secondary">Read more</a>
          </div>
        </div>
      </div>
    <% end %>
  </div>
</div>
<script>
  const div1 = document.getElementById("1");
  const btn1 = document.getElementById("btn1");
  const div2 = document.getElementById("2");
  const btn2 = document.getElementById("btn2");
  btn2.onclick = function () {
    if (div1.style.display !== "none") {
      div1.style.display = "none";
      div2.style.display = "block";
    }
  };
  btn1.onclick = function () {
    if (div2.style.display !== "none") {
      div1.style.display = "block";
      div2.style.display = "none";
    }
  };
</script>

project/app/views/home/_header.html.erb
<nav class="navbar navbar-expand-lg navbar-light bg-white">
  <div class="container-fluid">
    <%= link_to 'Home', root_path, class:"navbar-brand"%>
    <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation">
      <span class="navbar-toggler-icon"></span>
    </button>
    <div class="collapse navbar-collapse" id="navbarSupportedContent">
      <ul class="navbar-nav me-auto mb-2 mb-lg-0">
        <li class="nav-item">
          <%= link_to 'About', home_about_path, class:"nav-link"%>
        </li>
      </ul>
      <div id="user_status">
        <% if user_signed_in? %>
          Welcome <%= current_user.email %>!
          <%= link_to "Sign out", destroy_user_session_path, method: :delete %>
        <% else %>
          <%= link_to "Sign up", new_user_registration_path %> or
          <%= link_to "Sign in", new_user_session_path %>
        <% end %>
      </div>
    </div>
  </div>
</nav>

project/app/views/home/about.html.erb
<h1> About us </h1>
<p> This is the webpage is for group Web10</p>

project/app/views/home/index.html.erb
<h2>Assignment</h2>
<br>
<div class="card" style="width: 30rem">
  <h5 class="card-header">Problem Set 1</h5>
  <div class="card-body">
    <ul style="list-style-type:disc">
      <li class= "mb-3">
        <%= link_to 'Divide by zero', assignment_divide_path%>
      </li>
      <li>
        <%= link_to 'News portal', assignment_news_path%>
      </li>
    </ul>
  </div>
</div>

project/app/views/layouts/_footer.html.erb
<footer style= " bottom:0; width:100%; position:fixed; background-color: #c0c8d1;height: 2.5rem;">
  <div style= "text-align:center; ">
    <a  href= "https://validator.w3.org/check?uri=<%= @url %>" class="btn btn-secondary" target="_blank">Validator</a></div>
</footer>

project/app/views/layouts/application.html.erb
<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width,initial-scale=1">
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>
    <%= stylesheet_link_tag 'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_pack_tag 'application', 'data-turbolinks-track': 'reload' %>
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.1.1/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-F3w7mX95PdgyTmZZMECAngseQB83DfGTowi0iMjiWaeVhAn4FJkqJByhZMI3AhiU" crossorigin="anonymous">
    <title>Web10</title>
  </head>
  <body >
    <%= render 'home/header'%>
    <div class= 'container' style= "padding-bottom: 2.5rem;">
      <br>
      <%= yield %>
    </div>
    <%= render 'layouts/footer' %>
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.1.1/dist/js/bootstrap.bundle.min.js" integrity="sha384-/bQdsTh/da6pkI1MST/rWKFNjaCP5gBSY4sEBT38Q/9RBh9AH40zEOg7Hlq2THRZ" crossorigin="anonymous"></script>
  </body>
</html>